import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.lang.*;
import java.io.*;
import java.net.URL;
import java.util.*;

//--------------------------------------------------------//
//   vl^E					  //
//--------------------------------------------------------//
// NXꗗ
//  class FileFormatException t@CO
//  class planetarium         C
//  class ViewPanel           ʕ
//  class DatePanel           t̓pl
//  class ControlPanel        Rg[pl
//  class Stars               P
//--------------------------------------------------------//

//--------------------------------------------------------//
// t@CO
class FileFormatException extends Exception {
  public FileFormatException(String s) {
    super(s);
  }
}

//--------------------------------------------------------//
// C
public class planetarium extends Applet{
  Stars st;
  ViewPanel view;
  DatePanel date;
  ControlPanel cont;
  String message=null;

//--------------------------------------------------------//
  public void init(){
    String s;
    int month=1,day=1,hour=0;

    s=getParameter("month");
    if(s!=null) month=Integer.parseInt(s);
    s=getParameter("day");
    if(s!=null) day=Integer.parseInt(s);
    s=getParameter("hour");
    if(s!=null) hour=Integer.parseInt(s);

    getData();

    setLayout(new BorderLayout());
    view=new ViewPanel(st,month,day,hour,message);
    date=new DatePanel(view,month,day,hour);
    cont=new ControlPanel(view);
    add("North",date);
    add("Center",view);
    add("South",cont);
  }

//--------------------------------------------------------//
  public void destroy(){
    remove(view);
    remove(date);
    remove(cont);
  }

//--------------------------------------------------------//
  public void getData(){
    String starsname=null,constname=null,s;
    InputStream is1=null,is2=null;
    int x=135,y=35;

    starsname=getParameter("stars");
    if(starsname==null) starsname="stars.dat";
    constname=getParameter("constellation");
    if(constname==null) constname="constellation.dat";
    s=getParameter("longitude");
    if(s!=null) x=Integer.parseInt(s);
    s=getParameter("latitude");
    if(s!=null) y=Integer.parseInt(s);

    try{
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
      is1=new URL(getDocumentBase(),starsname).openStream();
      is2=new URL(getDocumentBase(),constname).openStream();
      st=new Stars(is1,is2,x,y);
    }
    catch(Exception e){
      st=null;
      message=e.toString();
    }
    try {
      if(is1!=null) is1.close();
      if(is2!=null) is2.close();
    }
    catch(Exception e) {
    }
  }
}

//--------------------------------------------------------//
// ʕ
class ViewPanel extends Panel
  implements MouseListener,KeyListener{
    Stars st;
    int px,py;
    int month,day,hour;                  // EE
    int direc=0,ddir=45;                 // Eω
    int str;                             // ̃|C^
    int fx,fy;                           // ʃTCY
    Color bgColor,textColor;             // wiFEF
    String message=null;
    boolean painted=true,textsw=false;
    Font font;

//--------------------------------------------------------//
  public ViewPanel(Stars st,int month,int day,int hour,String message){
    this.st=st;
    this.month=month;
    this.day=day;
    this.hour=hour;
    this.message=message;
    font=new Font("Monospaced",Font.PLAIN,14);
    bgColor=Color.black;
    textColor=Color.white;
    setBackground(bgColor);
    addMouseListener(this);
    addKeyListener(this);
  }

//--------------------------------------------------------//
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------//
  public void mousePressed(MouseEvent e){
    px=e.getX();
    py=e.getY();
    e.consume();
    str=st.getStar(px,py);
    if(str>=0){
      textsw=true;
      repaint();
    }
  }

//--------------------------------------------------------//
  public void mouseReleased(MouseEvent e){
  }

//--------------------------------------------------------//
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------//
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------//
  public void keyPressed(KeyEvent e){
  }

//--------------------------------------------------------//
  public void keyReleased(KeyEvent e){
  }

//--------------------------------------------------------//
  public void keyTyped(KeyEvent e){
    char keyin;

    keyin=(char)e.getKeyChar();
    switch(keyin){
      case '4':
      	turnLeft();
      	break;
      case '6':
      	turnRight();
      	break;
    }
  }

//--------------------------------------------------------//
  public void setDate(int month,int day,int hour){
// tݒ
    this.month=month;
    this.day=day;
    this.hour=hour;
    repaint();
  }

//--------------------------------------------------------//
  public void turnLeft(){
// ։]
    direc-=ddir;
    if(direc<-180) direc+=360;
    repaint();
  }

//--------------------------------------------------------//
  public void turnRight(){
// E։]
    direc+=ddir;
    if(direc>180) direc-=360;
    repaint();
  }

//--------------------------------------------------------//
  public void update(Graphics g) {
    if(textsw){
      st.paintText(g,str,px,py,fx,fy,bgColor,textColor);
      textsw=false;
    }
    else{
      g.setColor(bgColor);
      g.fillRect(0,0,fx,fy);
      st.drawStars(g,month,day,hour,direc,fx,fy);
      st.drawFrame(g,direc,fx,fy,bgColor,textColor);
    }
    painted=true;
  }

//--------------------------------------------------------//
  public void paint(Graphics g) {
    if (st!=null) {
      fx=getSize().width;
      fy=getSize().height;
      if(fx<300) fx=300;
      if(fy<150) fy=150;
      g.setFont(font);
      st.drawStars(g,month,day,hour,direc,fx,fy);
      st.drawFrame(g,direc,fx,fy,bgColor,textColor);
      painted=true;
    }
    else if(message!=null){
      g.setColor(textColor);
      g.drawString("Error in data:",3,20);
      g.drawString(message,10,40);
    }
  }
}

//--------------------------------------------------------//
// t̓pl
class DatePanel extends Panel
  implements ActionListener,ItemListener{
    ViewPanel view;
    Choice monthmenu=new Choice();
    Choice daymenu=new Choice();
    Choice hourmenu=new Choice();
    Button setDate=new Button("Set");
    String Month[]={"Jan","Feb","Mar","Apl","May","Jun"
      	      	   ,"Jul","Aug","Sep","Oct","Nov","Dec"};
    String Day[]=new String[31];
    String Hour[]=new String[24];
    int month,day,hour;

//--------------------------------------------------------//
  public DatePanel(ViewPanel view,int month,int day,int hour){
    int i;

    this.view=view;
    this.month=month;
    this.day=day;
    this.hour=hour;
    checkDate();
    setLayout(new FlowLayout());

    for(i=0;i<Month.length;i++){
      monthmenu.addItem(Month[i]);
    }
    monthmenu.select(month-1);
    monthmenu.addItemListener(this);
    add(monthmenu);

    for(i=0;i<Day.length;i++){
      Day[i]="day:"+(i+1);
      daymenu.addItem(Day[i]);
    }
    daymenu.select(day-1);
    daymenu.addItemListener(this);
    add(daymenu);

    for(i=0;i<Hour.length;i++){
      Hour[i]="hour:"+i;
      hourmenu.addItem(Hour[i]);
    }
    hourmenu.select(hour);
    hourmenu.addItemListener(this);
    add(hourmenu);

    setDate.addActionListener(this);
    add(setDate);
  }

//--------------------------------------------------------//
  public void actionPerformed(ActionEvent e){
// t̐ݒ
    if(e.getSource().equals(setDate)){
      view.setDate(month,day,hour);
    }
  }

//--------------------------------------------------------//
  public void itemStateChanged(ItemEvent e){
// tύX
    String TypeString=null;
    int i;

    if(e.getSource() instanceof Choice){
      TypeString=(String)e.getItem();
      for(i=0;i<Month.length;i++){
      	if(TypeString.equals(Month[i])) month=i+1;
      }
      for(i=0;i<Day.length;i++){
      	if(TypeString.equals(Day[i])) day=i+1;
      }
      for(i=0;i<Hour.length;i++){
      	if(TypeString.equals(Hour[i])) hour=i;
      }
      checkDate();
    }
  }

//--------------------------------------------------------//
  void checkDate(){
// tmF
    if(month==4 || month==6 || month==9 || month==11){
      day=Math.min(day,30);
    }
    else if(month==2){
      day=Math.min(day,29);
    }
  }
}

//--------------------------------------------------------//
// Rg[pl
class ControlPanel extends Panel implements ActionListener{
    ViewPanel view;
    Button left=new Button("turn Left");
    Button right=new Button("turn Right");

//--------------------------------------------------------//
  public ControlPanel(ViewPanel view){
    this.view=view;
    setLayout(new FlowLayout());

    left.addActionListener(this);
    add(left);
    right.addActionListener(this);
    add(right);
  }

//--------------------------------------------------------//
  public void actionPerformed(ActionEvent e){
// ̈ړ
    if(e.getSource().equals(left)){
      view.turnLeft();
    }
    else if(e.getSource().equals(right)){
      view.turnRight();
    }
  }
}

//--------------------------------------------------------//
// P
class Stars{
  int nmax=10000,ncon=100;            // PE̍ől
  int nofs,nofc;                      // PE
  String bayer[]=new String[nmax];    // P̃oCG
  String conste[]=new String[nmax];   // P̑鐯
  String name[]=new String[nmax];     // P̖O
  Color color[]=new Color[nmax];      // \F
  int radius[]=new int[nmax];         // \a
  double mecx[]=new double[nmax];     // ϐԌo
  double mecy[]=new double[nmax];     // ϐԈ
  double pmx[]=new double[nmax];      // ŗL^Ԍo
  double pmy[]=new double[nmax];      // ŗL^Ԉ
  double losv[]=new double[nmax];     // x
  double gcx[]=new double[nmax];      // o
  double gcy[]=new double[nmax];      // 
  double vmag[]=new double[nmax];     // 
  double trip[]=new double[nmax];     // Op
  double distance[]=new double[nmax]; // 
  String connom[]=new String[ncon];   // ̊w
  String consh[]=new String[ncon];    // ̗
  int gx[]=new int[nmax];             // ʏWʒu
  int gy[]=new int[nmax];
  int gz[]=new int[nmax];
  double x,y;                         // ϑn_̌oxEܓx

  Stars(){}

  Stars(InputStream is1,InputStream is2,int longitude,int latitude)
    throws IOException, FileFormatException {
    this();
    readStarData(is1);
    readConstData(is2);
    x=Math.PI*longitude/180.0;
    y=Math.PI*latitude/180.0;
    constellationName();
  }

//--------------------------------------------------------//
  void readStarData(InputStream is)
    throws IOException, FileFormatException{
// Pf[^ǂݍ
    int ii=0,colorR=0,colorG=0,colorB=0;
    double rad=Math.PI/180.0,hh,mm,ss;
    boolean EofF=false;

    StreamTokenizer st=new StreamTokenizer
      	      	      (new BufferedReader(new InputStreamReader(is)));
    st.eolIsSignificant(true);
    while(st.nextToken()!=StreamTokenizer.TT_EOL); // ڕǂݔ΂
    while (!EofF) {
      switch (st.nextToken()) {
      	default:
      	  EofF=true;                               // t@C[
      	  break;
      	case StreamTokenizer.TT_EOL:
      	  break;
      	case StreamTokenizer.TT_WORD:
      	  bayer[ii]=st.sval;
      	  if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	    conste[ii]=st.sval;
      	  if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	    name[ii]=st.sval;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    hh=st.nval;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    mm=st.nval;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    ss=st.nval;
      	  mecx[ii]=15.0*rad*(hh+mm/60.0+ss/3600.0);
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    mm=st.nval;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    ss=st.nval;
      	  if(mm<0.0) mecy[ii]=rad*(mm-ss/60.0);
      	  else mecy[ii]=rad*(mm+ss/60.0);
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    pmx[ii]=rad*st.nval/6.0e4;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    pmy[ii]=rad*st.nval/6.0e4;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    losv[ii]=st.nval;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    gcx[ii]=rad*st.nval;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    gcy[ii]=rad*st.nval;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    vmag[ii]=st.nval;
      	    radius[ii]=VmagToRad(vmag[ii]);
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    hh=st.nval;
      	  color[ii]=ColorIndexBV(hh);
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    trip[ii]=rad*st.nval/6.0e4;
      	  if(st.nextToken()!=StreamTokenizer.TT_NUMBER);
      	    distance[ii]=st.nval;
      	  ii++;
      	  if(ii==nmax) EofF=true;
      }
    }
    is.close();
    if(st.ttype!=StreamTokenizer.TT_EOF)
      throw new FileFormatException(st.toString());
    nofs=ii;
  }

//--------------------------------------------------------//
  void readConstData(InputStream is)
    throws IOException, FileFormatException{
// f[^ǂݍ
    int ii=0;
    boolean EofF=false;

    StreamTokenizer st=new StreamTokenizer
      	      	      (new BufferedReader(new InputStreamReader(is)));
    st.eolIsSignificant(true);
    while(st.nextToken()!=StreamTokenizer.TT_EOL); // ڕǂݔ΂
    while (!EofF) {
      switch (st.nextToken()) {
      	default:
      	  EofF=true;                               // t@C[
      	  break;
      	case StreamTokenizer.TT_EOL:
      	  break;
      	case StreamTokenizer.TT_WORD:
      	  connom[ii]=st.sval;
      	  if(st.nextToken()!=StreamTokenizer.TT_WORD);
      	    consh[ii]=st.sval;
      	  ii++;
      	  if(ii==ncon) EofF=true;
      }
    }
    is.close();
    if(st.ttype!=StreamTokenizer.TT_EOF)
      throw new FileFormatException(st.toString());
    nofc=ii;
  }

//--------------------------------------------------------//
  Color ColorIndexBV(double bv){
// FwB-V -> \F
    int rr,gg,bb;

    if(bv<=0.0){
      rr=255+(int)(765*bv);
      gg=255+(int)(255*bv);
      bb=255;
    }
    else if(bv<1.0){
      rr=255;
      gg=255;
      bb=255-(int)(255*bv);
    }
    else{
      rr=255;
      gg=510-(int)(255*bv);
      bb=0;
    }
    Color color=new Color(rr,gg,bb);
    return color;
  }

//--------------------------------------------------------//
  int VmagToRad(double vm){
//  -> \a
    int rad;

    rad=1+(int)(3.5-vm);
    return rad;
  }

//--------------------------------------------------------//
  void constellationName(){
// ̂̕ύX
    int i,j;

    for(i=0;i<nofs;i++){
      for(j=0;j<nofc;j++){
      	if(conste[i].equals(consh[j])) conste[i]=connom[j];
      }
    }
  }

//--------------------------------------------------------//
  double longitude(int month,int day,int hour){
// V̐ԌoiPj
    int yy=2000,dint;
    double jd,th;

    if(month<=2){
      yy--;
      month+=12;
    }
    dint=(int)(365.25*yy)+(int)(2.5e-3*yy)-(int)(1.0e-2*yy)
      	+(int)(30.59*(month-2));
    jd=(double)(dint+day)+hour/24.0+1721088.5;
    th=0.67239+1.00273781*(jd-2440000.5);
    th=2.0*Math.PI*(th-Math.floor(th));
    return th;
  }

//--------------------------------------------------------//
  void Coordinate(int month,int day,int hour,int direc,int fx,int fy){
// PWʒu
    int i,fx2;
    double xx,sy,cy,smy,cmy,cs,cc,sa,ca,angle,ipi4;
    double tol=1.0e-6;

    ipi4=2.0/Math.PI;
    fx2=fx/2;
    xx=longitude(month,day,hour);
    sy=Math.sin(y);
    cy=Math.cos(y);
    for(i=0;i<nofs;i++){
      smy=Math.sin(mecy[i]);
      cmy=Math.cos(mecy[i]);
      cs=cmy*Math.sin(mecx[i]-xx);
      cc=cy*smy-sy*cmy*Math.cos(mecx[i]-xx);
      sa=sy*smy+cy*cmy*Math.cos(mecx[i]-xx);
      ca=Math.sqrt(1.0-sa*sa);
      if(Math.abs(sa)>1.0-tol){
      	angle=0.0;
      }
      else{
      	angle=Math.acos(cc/Math.sqrt(cc*cc+cs*cs));
      	if(cs<0.0) angle=-angle;
      }
      angle=angle-Math.PI*direc/180.0;
      gx[i]=fx2+(int)(fy*Math.sin(angle)*ca);
      gy[i]=fy-(int)(fy*sa);
      gz[i]=(int)(fy*Math.cos(angle));
    }
  }

//--------------------------------------------------------//
  int getStar(int x,int y){
// NbN
    int i,dist;

    for(i=0;i<nofs;i++){
      if(gz[i]>=0){
      	dist=(gx[i]-x)*(gx[i]-x)+(gy[i]-y)*(gy[i]-y);
      	if(dist<=radius[i]*radius[i]) return i;
      }
    }
    return -1;
  }

//--------------------------------------------------------//
  void drawStars(Graphics g,int month,int day,int hour
      	      	,int direc,int fx,int fy){
// \
    int i;

    Coordinate(month,day,hour,direc,fx,fy);
    for(i=0;i<nofs;i++){
      if(gx[i]>=0 && gx[i]<=fx && gy[i]<=fy && gz[i]>=0){
      	g.setColor(color[i]);
      	g.fillOval(gx[i]-radius[i],gy[i]-radius[i]
      	      	  ,2*radius[i],2*radius[i]);
      }
    }
  }

//--------------------------------------------------------//
  void drawFrame(Graphics g,int direc,int fx,int fy
      	      	,Color bgColor,Color textColor){
// g\
    double angle,rad;
    int i,fx2,dx,dy,dx2,dy2;
    String dir[]={"N","NE","E","SE","S","SW","W","NW"};

    rad=Math.PI/180.0;
    fx2=fx/2;
    g.setColor(textColor);
    dx=fx/2+fy;
    dy=fy;
    for(i=1;i<=180;i++){
      dx2=fx2+(int)(fy*Math.cos(rad*i));
      dy2=fy-(int)(fy*Math.sin(rad*i));
      if(dx>=0 && dx2<=fx) g.drawLine(dx,dy,dx2,dy2);
      dx=dx2;
      dy=dy2;
    }

    for(i=0;i<dir.length;i++){
      angle=4.0*i/dir.length-direc/90.0;
      while(angle>2.0) angle-=4.0;
      while(angle<-2.0) angle+=4.0;
      dx=fx2+(int)(fy*angle);
      if(dx>0 && dx<fx){
      	FontMetrics fm=g.getFontMetrics();
      	int textl=fm.stringWidth(dir[i]);
      	int texth=fm.getHeight();
      	g.setColor(bgColor);
      	g.fillRect(dx-textl/2-1,fy-texth-2,textl+2,texth+2);
      	g.setColor(textColor);
      	g.drawString(dir[i],dx-textl/2,fy-1);
      }
    }
  }

//--------------------------------------------------------//
  void paintText(Graphics g,int pt,int x,int y,int fx,int fy
      	      	,Color bgColor,Color textColor){
// \
    int gx,gy;
    String text;

    if(pt!=-1){
// tHgݒ
      FontMetrics fm=g.getFontMetrics();
      text=conste[pt]+" "+bayer[pt];
      if(name[pt].equals("null")){}
      else text+=" "+name[pt];
      int textl=fm.stringWidth(text);
      int texth=fm.getHeight();

// \ʒu
      if(x<fx-textl-20) gx=x+2;
      else gx=x-textl-4;
      if(y<texth) gy=y+2;
      else if(y<fy-texth-10) gy=y-texth/2-1;
      else gy=y-texth-4;

// wiE\
      g.setColor(bgColor);
      g.fillRect(gx,gy,textl+2,texth+2);
      g.setColor(textColor);
      g.drawString(text,gx+1,gy+texth+1);
    }
  }
}
